<%-- $Id: list_trash.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Trashcan"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.query.ResultList"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%!
	private static final Item itemType = Item.SYSTEM;
	private static final String subContext = "trashcan";

	private static final Enumeration<String, String> items = new Enumeration<String, String>();
	static
	{
		for (Item item : Metadata.getRemovableItems())
		{
			items.add(item.name(), item.toString());
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, null, null);

final DbControl dc = sc.newDbControl();
ResultList<Removable> trash = null;
try
{
	long totalCount = 0;
	try
	{
		String filterItem = cc.getPropertyValue("type");
		Set<Item> itemTypes = null; 
		if (filterItem != null)
		{
			itemTypes = new HashSet<Item>();
			for (String name : filterItem.split("\\|"))
			{
				itemTypes.add(Item.valueOf(name));
			}
		}
		trash = Trashcan.getItems(dc, itemTypes, cc.getPage() * cc.getRowsPerPage(), cc.getRowsPerPage());
		totalCount = trash.getTotalCount();
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	%>
	<base:page title="Trashcan">
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'trashcan';
		function viewItem(itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id='+itemId, 'ViewJob', 740, 540);
		}
		function itemOnClick(evt, itemId)
		{
			viewItem(itemId);
		}
		function deleteAllItems()
		{
			if (!confirm('You are about to PERMANENTLY DELETE all item.\n This can\'t be undone. Continue?'))
			{
				return;
			}
			Main.openPopup('../../common/progress_reporter.jsp?ID=<%=ID%>&progress=trashcan&title=Empty trashcan', 'Progress', 400, 200);
			var frm = document.forms[formId];
			frm.action = submitPage;
			frm.cmd.value = 'DeleteAllPermanently';
			frm.submit();
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			var numChecked = Forms.numChecked(frm, /item:/);
			if (numChecked == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			else
			{
				var items = numChecked == 1 ? 'item' : 'items';
				if (!confirm('You are about to PERMANENTLY DELETE '+numChecked+' '+items+'.\n This can\'t be undone. Continue?'))
				{
					return;
				}
			}
			Main.openPopup('../../common/progress_reporter.jsp?ID=<%=ID%>&progress=trashcan&title=Delete items', 'Progress', 400, 200);
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItemsPermanently';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm, /item:/) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function showUsingItems(itemType, itemId)
		{
			var url = 'index.jsp?ID=<%=ID%>&cmd=ViewUsingItems&item_type='+itemType+'&item_id='+itemId;
			location.href = url;
		}
		</script>
	</base:head>
	
	<base:body>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="trashcan" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:columndef
				id="type"
				property="type"
				datatype="string"
				title="Item type"
				enumeration="<%=items%>"
				filterable="true"
				show="always"
			/>
			<tbl:columndef 
				id="name"
				title="Name"
				show="always" 
			/>
			<tbl:columndef id="id" 
				id="id"
				title="ID"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				title="Description"
			/>
			<tbl:toolbar>
				<tbl:button
					image="<%=totalCount > 0 ? "deleteall.png" : "deleteall_disabled.png"%>"
					onclick="deleteAllItems()"
					title="Empty trash&hellip;"
					tooltip="Delete all items from the trashcan"
					disabled="<%=totalCount <= 0%>"
				/>
				<tbl:button 
					image="<%=totalCount > 0 ? "delete_permanently.png" : "delete_permanently_disabled.png"%>"
					onclick="deleteItems()" 
					title="Delete permanently&hellip;" 
					tooltip="Delete the selected items permanently" 
					disabled="<%=totalCount <= 0%>"
				/>
				<tbl:button 
					image="<%=totalCount > 0 ? "restore.gif" : "restore_disabled.gif"%>"
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="Restore the selected items"
					disabled="<%=totalCount <= 0%>"
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=trash == null ? 0 : trash.getTotalCount()%>"
			/>
			<tbl:data>
				<tbl:columns>
					<tbl:presetselector 
						clazz="columnheader"
						colspan="3"
						onchange="presetOnChange()"
					/>
				</tbl:columns>
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId], /item:/)" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="icons" 
						>&nbsp;</tbl:header>
						
					<tbl:propertyfilter />
				</tr>

					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					if (trash != null)
					{
						for (Removable item : trash)
						{
							BasicItem basicItem = (BasicItem)item;
							boolean isUsed = basicItem.isUsed();
							int itemId = item.getId();
							String name = "";
							String description = "";
							if (item instanceof File)
							{
								File file = (File)item;
								name = file.getPath().toString();
								description = file.getDescription();
							}
							else if (item instanceof Directory)
							{
								Directory dir = (Directory)item;
								name = dir.getPath().toString();
								description = dir.getDescription();
							}
							else if (item instanceof Nameable)
							{
								Nameable nameable = (Nameable)item;
								name = nameable.getName();
								description = nameable.getDescription();
							}
							else
							{
								name = item.toString();
							}
							String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, true);
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="item:<%=item.getType().name()%>" 
										value="<%=itemId%>"
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									><base:icon 
										image="used.gif" 
										tooltip="This item is used by other items and cannot be deleted"
										visible="<%=isUsed%>"
										onclick="<%="showUsingItems('" + item.getType().name() + "', " +  itemId + ")"%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="type"><%=item.getType()%></tbl:cell>
								<tbl:cell column="name"><%=link%></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(description)%></tbl:cell>
							</tbl:row>
							<%
							}
						}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=trash == null || trash.size() == 0 ? "No items were found" : "No items on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=trash == null ? 0 : trash.getTotalCount()%>" 
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<br><br><br>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
